<?php
/**
  * Solicitud de revocació de cerificats.
  *
  * L'usuari que disposa d'un certificat signat en pot solicitar la revocació volutària, en cas que tingui un motiu que ho justifiqui (canvi de dades, ...)
  * es tramita la solicitud i la CA optarà per excutar la revocació.
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */

 require_once ('../page.php');
 session_start(); //control de la sessió de l'usuari
/**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class SolRev extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)

  }

  $solrev = new SolRev();
  if (isset($_SESSION['usuari'])) {
        $solrev -> content =" <form method='post' action='solRevocar.php'>
        <fieldset>
        <legend>Informació de l'usuari</legend>
        <p>
            Informació necessària <b>continguda al acertificat</b>  per tramitar la solicitud de revocació.
        </p>
        <table>
            <colgroup><col width='180px'></colgroup>
            <tr><th>Nom Complert(*)</th><td> <input type='text' name='usuari' value='' size='40'></td></tr>
            <tr><th>Correu Electrònic(*)</th><td> <input type='email' name='email' value='' size='30'></td></tr>
            <tr><th>Contrasenya(*)</th><td> <input type='password' name='passwd' value='' size='15'></td></tr>
        </table>
        <p>
            Motivació per la sol·licitud de revocació.
        </p>
        <table>
            <colgroup><col width='180px'></colgroup>
                <tr><th>Explicació breu</th><td><textarea rows='6' cols='70' name='explicacio'></textarea></td></tr>
        </table>
        <table>
                <tr><td ><input type='submit' name='enviar' value='Enviar sol·licitud'></td></tr>
        </table>
        </fieldset>
        </form>";
        //Recollim les dades
        if (isset ($_POST['enviar'])){
            $nom   = $solrev->Neteja($_POST['usuari']);
            $email = $solrev->Neteja($_POST['email']);
            $pass  = $solrev->Neteja($_POST['passwd']); //passwd
            $passX  = sha1($pass); //xifrem passwd
            $motiu = $solrev->Neteja($_POST['explicacio']);
            //Connectem amb la BD
            $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
            if (mysqli_connect_errno ()){
               $solrev-> content ="Error de connexió amb la Base de Dades".
                    mysqli_connect_errno ();
            } else
                if ($nom == "" || $email == "" || $motiu == "" || $pass == ""){
                    $solrev -> content = "Cal omplir totes les dades del formulari";
                } else
                    if (!$solrev->ValidaMail($email)){
                    $solrev -> content = "La adreça de correu ha de tenir un format correcte.";
                } else {
                    //Comprovem si exiteix el certificat
                    $resum = md5($pass.$email);
                    $query = " select * from certificats_clients where commonName ='$nom' and crt_descripc='$resum' ";
                    $results = $db->query($query);
                    if ($row = $results->fetch_array(MYSQLI_BOTH)) {
                        //$row = $results->fetch_array(MYSQLI_BOTH);
                        $solrev -> content = "El certificat està present a la BD:<br><br>".
                            $row['commonName']."<br>".
                            $row['organizationName']."<br>".
                            $row['organizationalUnitName']."<br>".
                            $row['emailAddress']."<br><br>";
                        
                        if ($row['revocat']== 1){
                            $solrev -> content .= "<b>El certificat ja estaba revocat</b>";
                        }
                        else if ($row['solrev']== 1){
                            $solrev -> content .= "<b>La sol·licitud de revocació ja estaba formulada</b>";
                        } else{
                            $ident = $row['crt_id'];
                            $query = "update certificats_clients set solrev = 1, motiurev = '$motiu' where crt_id = $ident";
                            $result = $db->query($query);
                            $solrev -> content .= "<b>S'ha tramitat la sol·licitud de revocació</b>";
                        }

                    } else {
                        $solrev -> content = "El certificat no està present present a la BD.";
                        }
                    }
                    //Si seleccionem comfirmar, aleshores actualitzem la BD i ho indiquem
                }
                //Tanquem la BD
                mysqli_close();


    /* El codi ha de realitzar una proposta justificada (canvi de dades,...)
    de revocació d'un certificat, aquesta proposta ha de quedar patent a una base de dades
    a revisar per part de l'administrador, en qui recau la reponsabilitat final de revocació
    */
  } else {
        $solrev -> content = "Error d'autenticació"."";
     }
  //Aquí el display
  $solrev -> Display();

?>