<?php
/**
 * Serveis als usuaris
 *
 * Pàgina que en ofereix els serveis de la autoritat de certificació.
 * S'inicia una sessió d'usuari que requerirà la autenticació del mateix. Un cop registrat/autenticat, l'usuari rep el primer cop una
 * breu descripció dels serveis oferts.
 * @author Eugeni Queralt
 * @package tfcUOC
*/
  require_once ('page.php');
  session_start(); //control de la sessió de l'usuari
/**
 * Extensió de la pàgina principal que mostra els serveis de la CA
 * @package tfcUOC
 */
  class ServicesPage extends Page
  {
    /**
     * Mostra una segona fila de botons
     *
     * @var array de botons amb enllaços als diferents serveis
     * @access private
     *
     */
    private $row2buttons = array( 'Llista de certificats revocats' 	 => '/tfc/ambCertificat/llistaCRL.php',
                              	  'Solicitud de Revocació'               => '/tfc/ambCertificat/solRevocar.php',
                            );
    /**
     * Mostra la pàgina de serveis.
     *
     * Sobrecarrega el mètode de la superclasse Page.
     */
    public function Display()
    {
      //echo "<html>\n<head>\n";
          $this -> DisplayCapcalera();
          $this -> DisplayTitle();
          $this -> DisplayKeywords();
          $this -> DisplayStyles();
          echo "</head>\n<body>\n";
          $this -> DisplayHeader();
          $this -> DisplayMenu($this->buttons);
          $this -> DisplayMenu($this->row2buttons);
          echo $this->content;//potser caldria fer-ho amb un mètode d'accés
          $this -> DisplayFooter();
          echo "</body>\n</html>\n";
        }
      }


  //Cal autenticar-se per accedir a aquesta secció

  $services = new ServicesPage();
  if (!isset ($_SESSION['usuari'])&& !isset($_POST['autenticar'])){
      $services -> content =" <form method='post' action=''>
        <fieldset>
        <legend>Cal identificar-se com a usuari registrat</legend>
        <p>
            Identificació d'usuari
        </p>
        <table>
            <colgroup><col width='180px'></colgroup>
                <tr><th>Usuari</th><td><input type='text' name='user' value='' size='15' maxlength='14'></td></tr>
                <tr><th>Contrasenya</th><td><input type='password' name='pass' size='15' maxlength='14'></td></tr>
        </table>

        <table>
                <tr><td ><input type='submit' name='autenticar' value='Ok'></td></tr>
        </table>
        </fieldset>
    </form>";

  } else {
      $services -> content = "Usuari autenticat";
  }

  if (isset($_POST['autenticar'])&&!isset ($_SESSION['usuari'])) {
      //Connectem amb la BD i verifiquem dades
      $db = new mysqli('localhost', 'keni','dbpass', 'tfcCA');
      if (mysqli_connect_errno ()){
              $services -> content ="Error de connexió amb la Base de Dades:".mysqli_connect_errno ();
      }
      $user = $services->Neteja($_POST['user']);
      $pass = sha1($services->Neteja($_POST['pass']));

      $query = "select * from usuaris where user = '$user' and passwd = '$pass'";
      $result = $db->query($query);
        
      if ($result->num_rows > 0){
          //Registrem la variable de sessió amb el
             $_SESSION['usuari'] = $user;
             $services -> content ="<b>Serveis als usuaris autenticats amb certificat de client:</b><br>".
                  "<b>Llista de certificats revocats:</b>Un cop autenticat pot accedir a la llista de certificats revocats de la CA.<br><br>".
                  "<b>Solicitud Revocació:</b> L'usuari ha d'estar registrat a la BD de certificats signats. Un cop autenticat pot sol·licitar
                      la revocació del seu certificat a la CA.<br><br>";
       } else
          {
             $services -> content = "Error d'autenticació";
          }
          mysqli_close();
  }
  //Neteja dels arxius utilitzats
  file_put_contents('/tmp/cert.pem', "");
  file_put_contents('/tmp/cert.p12', "");
  file_put_contents('/tmp/key.pem' , "");
  $services -> Display();
?>
