<?php
 /**
  * Peticions PKCS#10
  *
  * Pàgina que permet la introducció de peticions PKCS#10 a la autoritat de certificació. 
  * Requereix estar registrat i autenticat al sistema. El sistema recull la petició introduïda 
  * a un quadre de text i una contrasenya d'usuari,extreu la informació que necessita
  * per actualitzar la BD, neteja i valida els diferents elements, valida l'adreça de correu
  * proporcionada enviant un correu amb un text xifrat i finalment en passen les dades
  * al següent gestor per validar la confirmació del correu electrònic i tramitar la petició
  * de signatura a la CA.
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
 require_once ('../page.php');
 session_start(); //control de la sessió de l'usuari
  /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class ReqPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)

  }

  $req = new ReqPage();
  if (isset($_SESSION['usuari'])) {

      $req -> content =" <form method='post' action='csr.php'>
        <fieldset>
        <legend>Petició de l'usuari</legend>
        <p>
            Si heu generat la vostra pròpia petició pkcs#10, Enganxeu tot el contingut <br>
            des de -----BEGIN CERTIFICATE REQUEST----- <br>
            Fins   -----END CERTIFICATE REQUEST----- , inclosos  al següent <br>
            quadre de text:

        </p>
        <table>
            <colgroup><col width='180px'></colgroup>
            <tr><th>PKCS#10(*)</th><td> <textarea cols=70 rows=8 name='pkcs10'></textarea></td></tr>
        </table>
        <p>
            Caldrà introduir també una contrasenya per registrar l'usuari a la base de dades.
        </p>
        <table>
                <tr><th>Contrasenya(*)</th><td> <input type='password' name='passwd' value='' size='30'></td></tr>
                <tr><td ><input type='submit' name='enviar' value='Processar Petició'></td></tr>
        </table>
        </fieldset>
        Nota: La petició ha d'incloure una adreça de correu electrònic vàlida.
    </form>";

    if (isset($_POST['enviar'])) {
        if (($_POST['passwd']!='') && ($_POST['pkcs10']!=''))
            {
                //Netegem les entrades
                $pwd = $req -> Neteja($_POST['passwd']);
                $pkcs10 = $req -> Neteja($_POST['pkcs10']);

                //Obrim per escriptura
                if (!($Descriptor = fopen("/tmp/peticio.csr","w+"))) {
                    die("No es pot crear el fitxer");
                }
                //Posem la petició dins d'ell
                fwrite($Descriptor, $pkcs10);

                //Tanquem el fitxer
                fclose($Descriptor);

                //Mostra la informació sobre la petició de certificat
                exec("/usr/bin/openssl req -in /tmp/peticio.csr -subject -noout 2>&1", $revs);

                //Esborrem el contingut del fitxer
                if (!($Descriptor = fopen("/tmp/peticio.csr","w+"))) {
                    die("No es pot crear el fitxer");
                } else fclose($Descriptor);

                $cadena = $revs[0];
                unset($revs);

                $nom = $req -> treure($cadena,"/CN=","/");
                $org = $req -> treure($cadena,"/O=","/");
                $dept = $req -> treure($cadena,"/OU=","/");
                $pais = $req -> treure($cadena,"/C=","/");
                $prov = $req -> treure($cadena,"/ST=","/");
                $loc= $req-> treure($cadena,"/L=","/");
                $mailAdr = $req ->treure($cadena, "/emailAddress=", "|");

                //Connectem amb la BD
                $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
                if (mysqli_connect_errno ()){
                        die("Error de connexió amb la Base de Dades".
                    mysqli_connect_errno ());
                }
                $query = " select * from certificats_clients where commonName ='$nom' and revocat = 0";
                $results = $db->query($query);

                if (!($req->ValidaMail($mailAdr))||($nom == '')){
                    $req -> content = "La petició de certificat no conté cap nom i/o adreça de correu eletrònic vàlida.<br>
                        Si us plau, generar una altra vegada la petició i incloure el vostre nom i <br>
                        una adreça de correu electrònic vàlida.";
                }else if($results->fetch_array(MYSQLI_BOTH)){
                    // Si el Nom (commonName) està present a la BD de certificats  no es podrà fer la tramitació
                    $req -> content = "Existeix un certificat amb el mateix nom introduït seleccionat. <br>
                        sleccioneu un altre nom diferent al generar la petició";
                } else {
                    $resultat = "<br>"."Les dades ha estat ben introduïdes: <br><br>".$cadena."<br><br>".$nom."<br>".$org."<br>".
                    $req->Countries($pais)."<br>".$prov."<br>".$loc."<br>".$dept.
                    "<br>".$mailAdr."<br>";

                    $secret = sha1($pwd.$nom.$mailAdr);

                    $missatge = "Hola $nom,"."<br>".
                    "Aquest és un correu pel tal de confirmar l'adreça que has proporcionat al formulari de petició de certficat".
                    "Copia el seguent codi i enganxa'l on es demana a la pagina d'origen: ".
                    $secret.
                    " <br>".
                    "Salutacions, <br><br> TFC CA";
                    $missatge = wordwrap($missatge, 70);

                    //Aquí enviem el correu
                    $enviat = mail($mailAdr, "Missatge secret de TFC CA", $missatge);

                    $formulari = "
                    <p>
                    S'ha enviat un codi secret al correu proporcionat, introduiu-lo al següent cuadre de text.
                    </p>

                    <form method='post' action='csr0.php'>
                    <fieldset style='width: 400px;'>
                    <legend>Validació per Email</legend>
                        <p>
                        Introduiu el text xifrat aquí:
                        </p>
                        <table>
                            <colgroup><col width='180px'></colgroup>
                            <tr><th>Secret</th><td><input type='text' name='secret' value='' size='80'></td></tr>
                            <tr><td><input type='submit' value='Comprovar'></td></tr>
                        </table>
                    </fieldset>
                    <input type='hidden' name='secretc' value=$secret>
                    <input type='hidden' name='pwd'     value=$pwd>
                    <input type='hidden' name='nom'     value=\"".$nom."\">
                    <input type='hidden' name='org'     value=\"".$org."\">
                    <input type='hidden' name='pais'    value=\"".$pais."\">
                    <input type='hidden' name='prov'    value=\"".$prov."\">
                    <input type='hidden' name='loc'     value=\"".$loc."\">
                    <input type='hidden' name='dept'    value=\"".$dept."\">
                    <input type='hidden' name='mailAdr'  value=\"".$mailAdr."\">
                    <input type='hidden' name='pkcs10'  value=\"".$pkcs10."\">
                    </form>";

                    $req -> content = $resultat."<br><br>".$formulari;

                }
                mysqli_close();

            } else
                {
                $req -> content ="Comprova que has introduït les dades requerides";
                }
         }
  } else {
        $req -> content = "Error d'autenticació";
  }
  //Aquí el display
  $req ->Display();
?>
