<?php
/**
  * Recull i verifica les dades de d'usuari
  *
  * Requereix estar registrat i autenticat al sistema. El sistema recull i verifica les dades de d'usuari
  * amb les que generarà una clau privada i una petició, per actualitzar, després la BD, valida l'adreça de correu
  * proporcionada enviant un correu amb un text xifrat i finalment en passen les dades al següent gestor
  * per validar la confirmació del correu electrònic i tramitar la petició de signatura a la CA.
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */

 require_once ('../page.php');
 session_start(); //control de la sessió de l'usuari
   /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class ReqPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
    
  }

  $req = new ReqPage();
  if (isset($_SESSION['usuari'])) {
    $req -> content =" <form method='post' action='csr1.php'>
        <fieldset>
        <legend>Informació de l'usuari</legend>
        <p>
            Aquesta informació es mostrarà al certificat emès.
        </p>
        <table>
            <colgroup><col width='180px'></colgroup>
            <tr><th>Nom Complert(*)</th><td> <input type='text' name='usuari' value='' size='40'></td></tr>
            <tr><th>Correu Electrònic(*)</th><td> <input type='text' name='email' value='' size='30'></td></tr>
            <tr><th>Organització(*)</th><td> <input type='text' name='organitzacio' value='' size='25'></td></tr>
            <tr><th>Department</th><td> <input type='text' name='departament' value='Departament' size='30'></td></tr>
        </table>
        <p>
            Situació Geogràfica
        </p>
        <table>
            <colgroup><col width='180px'></colgroup>
                <tr><th>Població(*)</th><td><input type='text' name='Localitat' value='' size='25'></td></tr>
                <tr><th>Província</th><td><input type='text' name='Provincia' value='Provincia' size='25'></td></tr>
                <tr><th>País(*)</th><td><input type='text' name='Pais' value='' size='2'></td></tr>
                <tr><th>Contrasenya(*)</th><td><input type='password' name='passwd' size='15' maxlength='14'></td></tr>
        
        </table>
        <table>
                <tr><td ><input type='submit' name='enviar' value='Crear Petició'></td></tr>
        </table>
        </fieldset>
        (*) Camps obligatoris
    </form>";

    if (isset($_POST['enviar'])) {
        if (($_POST['email']!='') && ($_POST['usuari']!='')&& 
                ($_POST['organitzacio']!='')&& ($_POST['Pais']!='')&& 
                ($_POST['Localitat']!='') && ($_POST['passwd']!=''))
            {
                $pwd = $req -> Neteja($_POST['passwd']);
                $usuari = $req -> Neteja($_POST['usuari']);
                $org  = $req -> Neteja($_POST['organitzacio']);
                $pais = strtoupper($req -> Neteja($_POST['Pais']));
                $prov = $req -> Neteja($_POST['Provincia']);
                $loc  = $req -> Neteja($_POST['Localitat']);
                $dept  = $req -> Neteja($_POST['departament']);
                $correu = $req -> Neteja($_POST['email']);


                //Connectem amb la BD
                $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
                if (mysqli_connect_errno ()){
                        die("Error de connexió amb la Base de Dades".
                    mysqli_connect_errno ());
                }
                $query = " select * from certificats_clients where commonName ='$usuari' and revocat = 0";
                $results = $db->query($query);

                if (!$req->ValidaMail($correu)){
                    $req -> content ="Comprova que has introduït correctament el correu electrònic";

                } else if ($req -> Countries($pais) == null){
                    $req -> content ="Comprova que has introduït correctament el codi del país";

                } else if($results->fetch_array(MYSQLI_BOTH)){
                    // Si el Nom (commonName) està present a la BD de certificats  no es podrà fer la tramitació
                    $req -> content = "Existeix un certificat amb el mateix nom introduït seleccionat. <br>
                        sleccioneu un altre nom diferent al generar la petició";
                } else {

                    $resultat = "<br>"."Les dades ha estat ben introduïdes: "."<br><br>".$usuari."<br>".$org."<br>".
                    $req->Countries($pais)."<br>".$prov."<br>".$loc."<br>".$dept.
                    "<br>".$correu."<br>";
                    
                    $secret = sha1($pwd.$usuari.$correu);

                    $missatge = "Hola $usuari,"."<br>".
                    "Aquest és un correu pel tal de confirmar l'adreça que has proporcionat al formulari de petició de certficat.".
                    "Copia el seguent codi i enganxa'l on es demana a la pagina d'origen:   ".
                    $secret.
                    "<br>".
                    "Salutacions, <br><br> TFC CA";
                    $missatge = wordwrap($missatge, 70);

                    //Aquí enviem el correu
                    mail($correu, "Missatge secret de TFC CA", $missatge);

                    $formulari = "
                    <p>
                    S'ha enviat un codi secret al correu proporcionat, introduiu-lo al següent cuadre de text.
                    </p>

                    <form method='post' action='csr2.php'>
                    <fieldset style='width: 400px;'>
                    <legend>Validació per Email</legend>
                        <p>
                        Introduiu el text xifrat aquí:
                        </p>
                        <table>
                            <colgroup><col width='180px'></colgroup>
                            <tr><th>Secret</th><td><input type='text' name='secret' value='' size='80'></td></tr>
                            <tr><td><input type='submit' value='Comprovar'></td></tr>
                        </table>
                    </fieldset>
                    <input type='hidden' name='secretc' value=$secret>
                    <input type='hidden' name='pwd'     value=$pwd>
                    <input type='hidden' name='usuari'  value=\"".$usuari."\">
                    <input type='hidden' name='org'     value=\"".$org."\">
                    <input type='hidden' name='pais'    value=\"".$pais."\">
                    <input type='hidden' name='prov'    value=\"".$prov."\">
                    <input type='hidden' name='loc'     value=\"".$loc."\">
                    <input type='hidden' name='dept'    value=\"".$dept."\">
                    <input type='hidden' name='correu'  value=\"".$correu."\">
                    </form>";
       
                    $req -> content = $resultat.$formulari;
                }
                //Tanquem BD
                mysqli_close();
            } else
                {
                $req -> content ="Comprova que has omplert els camps obligatoris";
                }
        }
     } else {
        $req -> content = "Error d'autenticació";
      }
    //Aquí el display
    $req ->Display();
  ?>