<?php
/**
  * Tramita la emissió del certificat
  *
  * Recull i verifica les dades introduïdes per l'usuari respecte el seu certifica.
  * Comprova que el cerificat està signat i present a la BD i el mostra per un quadre de text en format PEM
  * Si es vol obtenir el corresponent PKCS#12 es demana la clau privada de l'usuari i el password amb això
  * s'accedirà a l'emissió el corresponent certificat.
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
 require_once ('../page.php');
 session_start(); //control de la sessió de l'usuari

  /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class EmetCert extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)

  }

  $emet = new EmetCert();

  if (isset($_SESSION['usuari'])) {

        //Recollim les dades
        $nom   = $_POST['usuari'];
        $email = $emet->Neteja($_POST['email']);
        $pass  = $emet->Neteja($_POST['passwd']); //passwd
        $passX  = sha1($pass); //xifrem passwd
        //Connectem amb la BD
        $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
        if (mysqli_connect_errno ()){
           $emet-> content ="Error de connexió amb la Base de Dades".
                mysqli_connect_errno ();
        } else
            if ($nom == "" || $email == "" || $pass == ""){
                $emet -> content = "Cal omplir totes les dades del formulari";
            } else
                if (!$emet->ValidaMail($email)){
                $emet -> content = "La adreça de correu ha de tenir un format correcte.";
            } else {
                //Comprovem si exiteix el certificat
                $resum = md5($pass.$email);
                $accents = $db->query("SET NAMES 'utf8'");
                $query = " select * from certificats_clients where commonName = '$nom' and crt_descripc='$resum' ";
                $results = $db->query($query);
                if ($row = $results->fetch_array(MYSQLI_BOTH)) {
                    //$row = $results->fetch_array(MYSQLI_BOTH);
                    $emet -> content = "El certificat està present a la BD:<br><br>".
                        $row['commonName']."<br>".
                        $row['organizationName']."<br>".
                        $row['organizationalUnitName']."<br>".
                        $row['emailAddress']."<br><br>";

                    if ($row['revocat']== 1){
                        $emet -> content .= "<b>El certificat està revocat</b>";
                    }
                    else if ($row['solrev']== 1){
                        $emet -> content .= "<b>El certificat està pendent de ser revocat</b>";
                    } else{
                        //Demanem la clau privada xifrada, si s'ha desat al crear la petició
                        $querykey = " select * from peticions_csr where commonName ='$nom' and csr_descripc='$resum' ";
                        $resultskey = $db->query($querykey);
                        $rowkey = $resultskey->fetch_array(MYSQLI_BOTH);
                        $clauPrivada=$rowkey['pkeypem'];//mirar com passar-la!!!!

                        $certpem = $row['certpem'];
                        $emet -> content .= "
                            <form method='post' action='pkcs12.php'>
                            <fieldset>
                            <legend>Emissió de certificat</legend>
                             <p>
                             <ul>
                                <li>Si es vol emetre el certificat en format PKCS#12, cal enganxar (si no ho està) al seguent quadre de text
                                La clau privada xifrada amb la contrasenya proporcionada.</li>
                                <li>Si la clau privada es troba ja a la BD i es es vol
                                eliminar després d'emetre el certificat selecionar el quadre corresponent.</li>
                            </ul>
                             </p>
                            <table>
                                <colgroup><col width='180px'></colgroup>
                                <tr>
                                <th>Certificat PEM:</th><td><textarea rows='15' cols='70' name='certpem'>$certpem</textarea></td>
                                <th>Clau privada xifrada:</th><td><textarea rows='15' cols='70' name='textpkey'>$clauPrivada</textarea></td>
                                </tr>
                                <tr>
                                <th></th>
                                <th><th></th>
                                <th><input type='checkbox' name='checkbox[]' value ='delpkey'> Esborrar clau privada de la BD</th>
                                </tr>
                            </table>
                                <input type='submit' name='generar' value='Generar certificat PKCS#12'>
                                <input type='hidden' name='pass'    value=\"".$pass."\">
                                <input type='hidden' name='nom'     value=\"".$nom."\">
                                <input type='hidden' name='pkey'    value=\"".$clauPrivada."\">
                            </fieldset>
                            </form>";

                }

                } else {
                    $emet -> content = "No es troba. El certificat de $nom no està present present a la BD, o bé no has entrat
                        correctament les dades.";
                    }
                }
                //Si seleccionem comfirmar, aleshores actualitzem la BD i ho indiquem
                //Tanquem la BD
            mysqli_close();
        } else {
        $emet-> content = "Error d'autenticació";
      }
  //Aquí el display
  $emet -> Display();

?>