<?php
/**
  * Emissió de certificats PEM i PKCS#12
  *
  * Recull el certificat PEM signat de l'usuari i la clau privada del mateix usuari i emet el
  * corresponent certificat PKCS#12
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
 require_once ('../page.php');
 session_start(); //control de la sessió de l'usuari
/**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class Emetpkcs12 extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)

  }

  $pkcs12 = new Emetpkcs12();

  if (isset($_SESSION['usuari'])) {

        //Recollim les dades
        $x509 = $pkcs12->Neteja($_POST['certpem']);

        //Prenem la clau privada de la BD si hi és!
        $p_key = $pkcs12->Neteja($_POST['pkey']);
        //Prenem la clau privada del quadre de text, proporcionada pel client si hi és!
        if ($p_key == ""){
            $p_key = $pkcs12->Neteja($_POST['textpkey']);
        }
        file_put_contents('/tmp/key.pem' , $p_key);
        file_put_contents('/tmp/cert.pem', $x509);

        $pass  = $pkcs12->Neteja($_POST['pass']);
        $nom   = $_POST['nom'];
        $delpkey  = $pkcs12->Neteja($_POST["checkbox"][0]);

        //Desxifrem la clau privada
        $priv_key = openssl_pkey_get_private($p_key, $pass);
        $iis='/tmp/cert.p12';

        //Es comprimeix amb el mateix password amb la que xifrem la clau privada. Posteriorment s'ha de descarregar
        if(openssl_pkcs12_export_to_file($x509, $iis , $priv_key, $pass)){
                $pkcs12 -> content = "
                 <form method='post' action='/tfc/serveis.php'>
                 <fieldset>
                    <legend>Emissió de certificat</legend>
                     <p>
                     <ul>
                        <li>El certificat s'ha exportat correctament a l'arxiu al format corresponent PKCS #12. </li>
                        <li>$nom Pots descarregar el arxius i i tornar a la pàgina de serveis.</li>
                        <li>Si has seleccionat esborrar la clau privada de la BD, pots descarregar-la abans.</li>
                     </ul>
                    </p>
                    <table>
                        <colgroup><col width='180px'></colgroup>
                        <tr><th>Certificat PEM:</th><td><a href='descarregar.php?f=cert.pem'><img src = '/tfc/imatges/down.jpeg'></a></td></tr>
                        <tr><th>Clau privada xifrada:</th><td><a href='descarregar.php?f=key.pem'><img src = '/tfc/imatges/down.jpeg'></a></td></tr>
                        <tr><th>Certificat PKCS#12:</th><td><a href='descarregar.php?f=cert.p12'><img src = '/tfc/imatges/down.jpeg'></a></td></tr>
                        <tr><th><input type='submit' name='tornar' value='Ok'><th></tr>
                    </table>
                  </fieldset>
                  </form>";

            //Connectem amb la BD
            $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
            if (mysqli_connect_errno ()){
                $pkcs12-> content ="Error de connexió amb la Base de Dades".
                mysqli_connect_errno ();
            } 
            if($delpkey=="delpkey"){
                $query = "update peticions_csr set pkeypem='' where commonName='$nom'";
                $result = $db->query($query);
            }
            //Tanquem BD
            mysqli_close();
        } else {
            $pkcs12 -> content ="El certificat NO s'ha exportat a l'arxiu corresponent ";
        };

        
   } else {
        $pkcs12-> content = "Error d'autenticació";
   }
  //Aquí el display
  $pkcs12-> Display();

?>